// mm.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "mm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

#define ASIZE 256

void OUTPUT(unsigned long pos,
			unsigned char *pat,
			unsigned char *fix,
			int fixlen,
			CFile *pf)
{
	printf("%ld %s -> %s\n",pos,pat,fix);
	if(pf)
	{
		pf->Seek(pos,CFile::begin);
		pf->Write(fix,fixlen);
	}
}

void preQsBc(unsigned char *pat,int m,int qsBc[])
{
	register int i;
	for (i=0;i<ASIZE;++i)
		qsBc[i]=m+1;
	for (i=0;i<m;++i)
		qsBc[(unsigned char)pat[i]]=m-i;
}

void QS(unsigned char *x, int m,unsigned char * y,unsigned long n,
		unsigned char *f, int l,CFile *pf)
{
	register unsigned long j;
	register int qsBc[ASIZE];
	register unsigned char *text,*pat;
	text = (unsigned char*)y;
	pat = (unsigned char*)x;
	/* preprocessing */
	preQsBc(pat,m,qsBc);
	/* Searching */
	j=0;
	while (j<=n-m)
	{
		if (memcmp(pat,text+j,m)==0)
			OUTPUT(j,pat,f,l,pf);
		j+=qsBc[text[j+m]]; //shift
	}
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	CFile f;
	typedef struct _ft
	{
		unsigned char s[50];
		unsigned char d[50];
	}FT,*pFT;
	FT ft[]={
		{"_wfopen_s","_wfopen"},
		{"_wsopen_s","_wsopen"},
		{"wcstok_s","wcstok"},
		{"_vsnprintf_s","_vsnprintf"},
		{"strncpy_s","strncpy"},
		{"swscanf_s","swscanf"},
		{"strtok_s","strtok"},
		{"GetNumaNodeProcessorMaskEx","GetNumaNodeProcessorMask"},
		{"InitializeConditionVariable","InitializeCriticalSection"},
		{"SetThreadGroupAffinity","SetThreadAffinityMask"},
		{"SleepConditionVariableCS","LeaveCriticalSection"},
		{"WakeAllConditionVariable","EnterCriticalSection"},
		};
	if(argc<2) return -1;
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0)) return -2;
	if(!f.Open(argv[1],CFile::modeReadWrite)) return -3;
	unsigned long size = f.GetLength();
	//printf("size = %ld\n", size );
	unsigned char *pbuf = (unsigned char *) malloc( size +1 );
	if(!pbuf) return -4;
	DWORD readsize = f.ReadHuge(pbuf,size);
	//printf("read = %ld\n",readsize);

	for(int j=0; j<sizeof(ft)/sizeof(FT); j++)
	{
		QS(ft[j].s,strlen((char*)(ft[j].s)),pbuf,size,
			ft[j].d,strlen((char*)(ft[j].s)),
			&f);
	}
	/*
	for(DWORD i=0;i<size;i++)
	{
		for(int j=0; j<sizeof(ft)/sizeof(FT); j++)
		{
			if(memcmp(pbuf+i,ft[j].s,strlen(ft[j].s)) == 0)
			{
				printf("%s find at %ld\n",ft[j].s,i);
				f.Seek(i,CFile::begin);
				f.Write(ft[j].d,strlen(ft[j].s));
				printf("%s fix to %s\n",ft[j].s,ft[j].d);
			}
		}
	}
	*/
	free(pbuf);
	f.Close();
	return 0;
}


